<?
/**
* ActionScript Highlighter v2
* ----------------------------
modified from Martin DUBUC's ash, bug fixed and added support for ActionScript 2

**************************************************************
* Developed by R.Arul Kumaran [arul@shockwave-india.com]     *
* for more code keep visiting [www.shockwave-india.com/blog] *
**************************************************************
*/

class ash
{
function ash()
{
# Language name.
$this->lang_name             = "ActionScript MX 2";

     //array("#000000", "#993300", "#000087", "#000087", "#993300", "#000087", "#993300");
     //array("operator", "keyword", "identifier", "properties", "externalIdentifier");
    
# Configure your font face / size
$this->preStyle = "\n    pre {font-family:\"Courier New\", Courier, Arial; font-size: 12px;}\n";
$this->preStyle .= "    .operator {color: #000000;}\n";
$this->preStyle .= "    .keyword {color: #993300;}\n";
$this->preStyle .= "    .identifier {color: #000087;}\n";
$this->preStyle .= "    .properties {color: #000087;}\n";
$this->preStyle .= "    .identifier2 {color : #000087;}\n"; //".identifier2 {color : #993300;}\n";
$this->preStyle .= "    .linecomment, .blockcomment {color: #808080;}\n";
$this->preStyle .= "    .string {color: #0000FF;}\n";
//
# Language configuration hashtable.
$this->config                 = array();
$color                         = 0;
$parsing                    = "";
$this->_BUFFER                = "";
$this->validkeys            = array();
$this->indent                = array();
$this->unindent                = array();
$this->blockcommenton         = "";
$this->blockcommentoff        = "";
$this->linecommenton        = "";

# Hashtable of keywords - maps from keyword to colour.
$this->keywords                = array();

#print method
$this->printMethod = "print";

# Used for conversion from keyword -> regexp.
$this->keypats                = array();

# Which colours to use for each 'level'.
$this->colours                = array();
$this->quotecolour            = "blue";
$this->blockcommentcolour    = "green";
$this->linecommentcolour    = "green";
$this->stringchars            = array("\'", "\"");
$this->delimiters            = array();
$this->escchar                = "";

# Caches for the harvesters.
$this->comcache                = "";
$this->stringcache            = "";

# Toggles
$this->perl                    = 0;
$this->notrim                = 0;
$this->nocase                = 0;
}

######### Highlighting functions
# Load a file and return it as a (big :-) string.
function ash_load_file($filename)
{
    $filehandle = fopen ($filename, "r") or die("Could not open $filename for reading.");
    $text = fread($filehandle, filesize($filename));
    fclose($filehandle);
    return $text;
}   

# Do the brunt work of highlighting the text. Harvesting can be set through the latter two
# arguments.
function ash_highlight_text($text, $cachecomments=0, $cachestrings=0)
{    
    //$text = stripslashes($text);
    
    
    $text = str_replace("&", "&amp;", $text);
    $text = str_replace("<", "&lt;", $text);
    $text = str_replace(">", "&gt;", $text);
    $inquote     = 0;
    $incomment    = 0;
    $inbcomment     = 0;
    $inwhitespace     = 1;
    # Get the lines.
    $arr         = preg_split("/\n/", $text);
    # Current indent level.
    $ind         = 0;
    # Retrieve the values from the config. More for readability than anything.
    $bkc         = $this->blockcommenton;
    $bku         = $this->blockcommentoff;
    $lnc        = $this->linecommenton;

    if ($bku=="") unset($bku);
    if ($bkc=="") unset($bkc);
    if ($lnc=="") unset($lnc);

    # Store the lengths of the comment strings - saves recalculating them lots.
    $bkcl        = strlen($bkc);
    $bkul        = strlen($bku);
    $lncl        = strlen($lnc);

    # Clear the harvest caches.
    $this->comcache    = "";    
    $this->stringcache    = "";
    
    # Used to ensure quote matching works :-)
    $currquotechar    = "";
    $begseen    = 0;    
    $newline    = 0;
    $escaping    = 0;
    $escape_counter = 0;
    
    # Used by $this->munge for keyword checking - we only want to make this once.
    $this->validkeys = array();

    foreach(array_keys($this->keywords) as $key)
    {
        if ($this->nocase)
            $this->validkeys[strtolower($key)] = $key;
        else
            $this->validkeys[$key] = $key;
    }
    $alldelims = array_merge($this->delimiters, $this->stringchars);
    ##SIZE
    $this->printIt("<style>$this->preStyle</style>\n\n");
    $this->printIt("<pre>");
    foreach ($arr as $line)
    {
        $inwhitespace = 1;
        # Close any hanging font tags.
        if ($incomment)
        {
            $tmpComment = 1;
            $this->printIt("</span>");
        }
        else {
            $tmpComment = 0;
        }
        $incomment = 0;
        # Strip leading and trailing spaces
        if ($this->notrim==0) $line = trim($line);
        
        $lineout = "";
        $lineorig = $line;
        # $printMethod out the current indent.
        $sw = $this->starts_with($lineorig, $this->unindent);

        if ($ind>0 && $sw!="")
        {
            $lineout = str_repeat("        ", ($ind-1));
        }
        else
        {
            $lineout = str_repeat("        ", $ind);
        }
        if (strpos($oldline,"("))
            {
                $openPar++;
                if (strpos($line,")"))
                {
                    $openPar--;
                    $closePar++;
                }
                if ($openPar > 0)
                    {
                    $tmpInd += 1+strrpos($oldline,"(");
                    }
                else
                    {
                    
                    $tmpInd = 1+strrpos($oldline,"(");
                    }
            }
        
        if ( (!$tmpComment) && (($oldline[strlen($oldline)]==",") || ($oldline[strlen($oldline)-1]==",")) )
        {
            $lineout .= str_repeat(" ", ($tmpInd));
        }

        $ln = strlen($lineorig);
        for ($j=0; $j<$ln; $j++)
        {
            $currchar = $lineorig[$j];

            # Handle line comments. This is made slightly faster by going straight to
            # the next line - as nothing else can be done.
            if (isset($lnc) && (substr($line, $j, $lncl)==$lnc) && !$inquote && !$incomment && !($this->perl && $j>0 && $line[$j-1]=="$"))
            {
                $line = substr($line, $j);
                $lineout = $this->munge($lineout);
                $this->printIt($lineout);
                $this->printIt("<span class='$this->linecommentcolour'>$line");
                if ($cachecomments) $this->comcache .= " ".substr($line, $lncl);
                $lineout = "";
                $incomment = 1;
                $j = $ln + 1;
                continue;
                
            }
            # Handle opening block comments. Sadly this can't be done quickly (like with
            # line comments) as we may have 'foo /* bar */ foo'.
            if (isset($bkc) && (substr($line, $j, $bkcl)==$bkc) && !$inquote && !$inbcomment)
            {
                $lineout = $this->munge($lineout);
        
                $this->printIt($lineout);
                $this->printIt("<span class='$this->blockcommentcolour'>$bkc");
                $lineout = "";
                $inbcomment = 1;
                $j += $bkcl-1;
                continue;
            }
            # Handle closing comments.
            if (!$inquote && isset($bku) && $inbcomment && (substr($line, $j, $bkul)==$bku))
            {
                $lineout .= "$bku</span>";
                $this->printIt($lineout);
                $lineout = "";
                $inbcomment = 0;
                $j += $bkul;
                continue;
            }
            # If we're in a comment, skip keyword checking, cache the comments, and go
            # to the next char.
            if ($incomment || $inbcomment)
            {
                $lineout .= $currchar;
                if ($newline)
                {
                    if ($cachecomments) $this->comcache .= " ";
                    $newline = 0;
                }
                if ($cachecomments) $this->comcache .= $currchar;
                continue;
            }
            
            # Indent has to be either preceded by, or be, a delimiter.
            $delim = ($j==0 || in_array($currchar, $alldelims) || ($j>0 && in_array($lineorig[$j-1], $alldelims)));
            
            # Handle quotes.    
            if (!$escaping && in_array( $currchar, $this->stringchars))
            {
                //echo  $lineorig[$j-7].$lineorig[$j-6].$lineorig[$j-5].$lineorig[$j-4].$lineorig[$j-3].$lineorig[$j-2] == "\\\\\\\\\\\\" ;
                $test =($escape_counter-1)/2;
                //echo  $test % 2 == 1;
                //echo ' count = '.$test.'   prevChar = ['.$lineorig[$j-7].$lineorig[$j-6].$lineorig[$j-5].$lineorig[$j-4].$lineorig[$j-3].$lineorig[$j-2].'];<br/>';
                
                # First quote, so go blue.
                if (isset($inquote) && !$inquote)
                {    
                    $lineout = $this->munge($lineout);
                    $this->printIt($lineout);
                    $inquote = 1;
                    if ($cachestrings) $this->stringcache.=" ";
                    $lineout = "<span class='$this->quotecolour'>".$currchar;
                    $currquotechar = $currchar;
                }
                # Last quote, so turn off font colour.
                else if ($currchar == $currquotechar &&  $test % 2 == 0) //($lineorig[$j-3].$lineorig[$j-2] !== "\\\\" )|| $lineorig[$j-7].$lineorig[$j-6].$lineorig[$j-5].$lineorig[$j-4].$lineorig[$j-3].$lineorig[$j-2] == "\\\\\\\\\\\\"
                {
                    
                    $inquote = 0;
                    $lineout .= $lineorig[$j]."</span>";
                    $this->printIt($lineout);
                    $lineout = "";
                    $currquotechar = "";
                } else {
                # escapled quote so leave it as is
                    $lineout .= $currchar;
                }
            }
            
                    
            # If we've got an indent character, increase the level, and add an indent.
            else if ($delim && !$inquote && ($stri=$this->starts_with(substr($line, $j), $this->indent))!="")
            {

                if (!$inwhitespace)
                {
                    $lineout .= str_repeat("        ", $ind);
                }
                $lineout .= $stri;
                $ind++;
                $j += strlen($stri)-1;
                
            }
            # If we've got an unindent (and we are indented), go back a level.
            else if ($delim && $ind>0 && !$inquote && ($stru=$this->starts_with(substr($line, $j), $this->unindent))!="")
            {

                $ind--;
                
                if (!$inwhitespace)
                {
                    $lineout .= str_repeat("        ", $ind);
                }
                $lineout .= $stru;
                
                $j += strlen($stru)-1;
            }
            # Add the characters to the output, and cache strings.
            else if (!$inwhitespace || $currchar != " " || $currchar != "\t")
            {
                if ($inquote && $cachestrings)
                    $this->stringcache.=$currchar;
                $lineout .= $currchar;
            }
            if ($inquote && $escaping)
            {
                $escaping = 0;
            }
            else if ($inquote && $currchar == $this->escchar && !$escaping)
            {
                $escaping = 1;
            }
            //added by arul
            
            $currchar == '\\' ? $escape_counter= $escape_counter+1 : $escape_counter = 0;        
            //echo $escape_counter.' curChar = ['.$currchar.'] <br/>';
        }
        
        
        
        
        
        if ($currchar != " " && $currchar != "\t")
        {
            $inwhitespace = 0;
        }
        if (!$incomment && !$inbcomment && !$inquote)
        {
            $lineout = $this->munge($lineout);
        }
        $lineout .= "\n";
        
        if (strpos($line,";"))
            $tmpInd=0;
        
        $oldline = $lineorig;
        $this->printIt($lineout);
        $newline = 1;
    }
    # If we've finished, and are still in a comment, close the font tag.
    if ($incomment || $inbcomment)
    {
        $this->printIt("</span>");
    }
    $this->printIt("</pre>");
}

# Go through the string, highlighting keywords.
function munge($munge)
{    
    $munge     = str_replace("&amp;","&", $munge);
    $munge     = str_replace("&gt;", ">", $munge);
    $munge     = str_replace("&lt;","<", $munge);
    $inword     = 0;
    $currword     = "";
    $currchar     = "";
    $strout     = "";
    $lngth         = strlen($munge);

    for($i=0; $i<=$lngth; $i++)
    {
        $currchar = $munge[$i];
        $delim = in_array($currchar, $this->delimiters);
        if ($delim || $i==($lngth))
        {
            if ($inword)
            {
                $inword = 0;
                $oldword = $currword;
                
                $checkword = $oldword;
                if ($this->nocase) $checkword = strtolower($checkword);
                $currword = str_replace("&", "&amp;", $currword);
                $currword = str_replace("<", "&lt;", $currword);
                $currword = str_replace(">", "&gt;", $currword);
                
                if (isset($this->validkeys[$checkword])) //in_array($checkword, array_keys($this->validkeys)))
                {
                    
                    if ($this->nocase) $checkword = $this->validkeys[$checkword];
                    $category = $this->keywords[$checkword];
                    $color = $this->colours[(int)($category)-1];
                    $fontchunk = "<span class=\"$color\">$currword</span>";
                    
                    ### TO DEBUG !!!
                    /*if (
                      isset($this->linkscripts) &&
                        (
                        $code = call_user_method($this->linkscripts{$category}, $this, $oldword)
                        ) != $oldword
                        )
                    {
                        $fontchunk = $code;
                    }*/
                    $strout .= $fontchunk;
                }
                else
                    $strout .= $currword;
            }
            $currchar = str_replace("&", "&amp;", $currchar);
            $currchar = str_replace("<", "&lt;", $currchar);
            $currchar = str_replace(">", "&gt;", $currchar);
            
            $strout .= $currchar;
        }
        else
        {
            if ($inword)
            {
                $currword .= $currchar;
            }
            else
            {
                $inword = 1;
                $currword = $currchar;
            }
        }
    }

    # Replace all symbols.
    $munge = htmlentities($munge);
    $munge = str_replace("&","&amp;",$munge);
    $munge = str_replace(">","&gt;",$munge);
    $munge = str_replace("<","&lt;",$munge);
    
    return $strout;
}

######### Statistics functions

# A handy function (which could probably be much smaller :-) to take
# a hashtable of 'word'->'occurrences' and return a hashtable of
# 'occurrences'->(array of words in alphabetical order).
function ash_get_sorted_count($unsorted)
{
    $sorted = array();
    foreach(array_keys($unsorted) as $k)
    {
        $num = $unsorted[$k];
        if (!isset($sorted[$num])) $sorted[$num] = array();
        array_push ($sorted[$num], $k);
    }
    krsort($sorted);
    foreach(array_keys($sorted) as $k)
    {
        $results = $sorted[$k];
        sort($results);
    }
    return $sorted;
}

# Produces a hashtable mapping from 'word'->'occurrences'. Also filters out common words, and
# any keywords in the language.
function ash_filter_words($comstring)
{
    $comstring = trim($comstring);
    $comout = array();
    $wordorder = array();
    $comstring = preg_replace ("/[^a-zA-Z ]/", " ", $comstring);
    $comstring = preg_replace ("/\s+/", " ", $comstring);
    $arr = explode(" ", $comstring);
    $commonwords = array("the", "and", "this", "that", "you", "then", "when", "who", "why", "what", "how", "with", "are", "may", "she", "him", "her");    
    foreach($arr as $a)
    {
        if (strlen($a)>3 && !in_array($a, $commonwords) && !in_array($a, array_keys($this->keywords)))
        {
            $a = strtolower($a);
            $comout[$a]++;
        }
    }

    return $comout;
}

######### Helper Functions

# A handy function to find the longest element of the array that is present at the beginning
# of the provided string. For example, given an array of 'foo' and 'foot' and the string 'football',
# this returns 'foot'.
function starts_with($text, $array)
{
    $ml = 0;
    $curr = "";
    
    foreach($array as $i)
    {
        $l = strlen($i);
        if (((!$this->nocase && substr($text, 0, $l)==$i) || ($this->nocase && strtolower(substr($text, 0, $l))==strtolower($i))) && ($text[$l]==" " || $l==1 || $text[$l]=="\n" || $text[$l]=="\t" || $text[$l]=="." || $text[$l]=="," || $text[$l]==";" || $l==strlen($text)))
        {
            if ($l>$ml)
            {
                $curr = substr($text, 0, $l);
                $ml = $l;
            }
        }
    }
    return $curr;
}


function printIt($text)
{
switch($this->printMethod) {
    case "print":
        print $text;
        break;
    default :
        print $text;
        break;
    case "buffer":
        $this->_BUFFER.=$text;
        //echo $this->_BUFFER;
        break;
    }
}


function ash_build_highlight_file($text,$resultFile,$cachecomments=0, $cachestrings=0)
{
    $this->_BUFFER="";

    $this->printMethod = "buffer";
    $this->ash_highlight_text($text,$cachecomments,$cachestrings);
    $fp = @fopen($resultFile,"w");
    if ($fp) {
        fwrite($fp,$this->_BUFFER);
    }
    else {
        echo "ASH can't open $resultFile for writing";
    }
    fclose($fp);
}

function ash_return_highlight_txt($text,$cachecomments=0, $cachestrings=0)
{
    $this->_BUFFER="";
    $this->printMethod = "buffer";
    $this->ash_highlight_text($text,$cachecomments,$cachestrings);
    return str_replace("&amp;#","&#",$this->_BUFFER);
}

}
?>
<?
class ash_as extends ash{
           function ash_as(){
                     $this->ash();    
                # Flags
                
                $this->nocase                = "0";
                $this->notrim                = "0";
                $this->perl                  = "0";
                
                # Colours
                //array("#000000", "#993300", "#000087", "#000087", "#993300", "#000087", "#993300");
                $this->colours            = array("operator", "keyword", "identifier", "properties", "identifier2");
                $this->quotecolour           = "string";
                $this->blockcommentcolour    = "blockcomment";
                $this->linecommentcolour     = "linecomment";
                
                # Indent Strings
                
                $this->indent                = array("{");
                $this->unindent              = array("}");
                $this->linebreak            = array(",");
                
                # String characters and delimiters
                
                $this->stringchars           = array("'", '"');
                $this->delimiters            = array("~", "!", "@", "%", "^", "&", "*", "(", ")", "-", "+", "=", "|", "\\", "/", "{", "}", "[", "]", ":", ";", "\"", "\'", "<", ">", " ", ",", "    ", ".", "?");//
                $this->escchar               = "";
                
                # Comment settings
                
                $this->linecommenton         = "//";
                $this->blockcommenton        = "/*";
                $this->blockcommentoff       = "*/";
                
                # Keywords (keyword mapping to colour number)
                
                $this->keywords              = array(
                //DEBUT DES CODES
                
                
                
                // OPERATEUR D ACTION SCRIPT :
                "--"    => "1",
                "++"    => "1",
                "!"    => "1",
                "!="    => "1",
                "%"    => "1",
                "%="    => "1",
                "&"    => "1",
                "&&"    => "1",
                "&="    => "1",
                "-"    => "1",
                "*"    => "1",
                "*="    => "1",
                ","    => "1",
                "."    => "1",
                "?:"    => "1",
                "/"    => "1",
                "^"    => "1",
                "^="    => "1",
                "|"    => "1",
                "||"    => "1",
                "|="    => "1",
                "~"    => "1",
                "+"    => "1",
                "+="    => "1",
                "<"    => "1",
                "<<"    => "1",
                "<<="    => "1",
                "<="    => "1",
                "<>"    => "1",
                "="    => "1",
                "=="    => "1",
                "-="    => "1",
                "-="    => "1",
                ">"    => "1",
                ">="    => "1",
                ">>"    => "1",
                ">>="    => "1",
                ">>>"    => "1",
                ">>>="    => "1",
                
                //arul
                "==="    => "1",
                "!=="    => "1",
                
// keywords
                "if" => "2",
                "while" => "2",
                "with" => "2",
                "var" => "2",
                "void" => "2",
                "typeof" => "2",
                "new" => "2",
                "delete" => "2",
                "do" => "2",
                "continue" => "2",
                "else" => "2",
                "add" => "2",
                "and" => "2",
                "or" => "2",
                "not" => "2",
                "on" => "2",
                "onClipEvent" => "2",
                "le" => "2",
                "lt" => "2",
                "gt" => "2",
                "for" => "2",
                "in" => "2",
                "function" => "2",
                "instanceof" => "2",
                "ge" => "2",
                "eq" => "2",
                "break" => "2",
                "#include" => "2",
                "ne" => "2",
                "return" => "2",
                "try" => "2",
                "catch" => "2",
                "finally" => "2",
                "throw" => "2",
                "switch" => "2",
                "default" => "2",
                "case" => "2",
                "#initclip" => "2",
                "#endinitclip" => "2",
                "class" => "2",
                "extends" => "2",
                "public" => "2",
                "private" => "2",
                "static" => "2",
                "interface" => "2",
                "implements" => "2",
                "import" => "2",
                "dynamic" => "2",
// identifiers
                "_root" => "3",
                "_parent" => "3",
                "_level" => "3",
                "MovieClip" => "3",
                "appendChild" => "3",
                "attachMovie" => "3",
                "attachSound" => "3",
                "loadSound" => "3",
                "attributes" => "3",
                "caller" => "3",
                "callee" => "3",
                "charAt" => "3",
                "charCodeAt" => "3",
                "childNodes" => "3",
                "clear" => "3",
                "cloneNode" => "3",
                "close" => "3",
                "concat" => "3",
                "connect" => "3",
                "createElement" => "3",
                "createTextNode" => "3",
                "docTypeDecl" => "3",
                "status" => "3",
                "duplicateMovieClip" => "3",
                "firstChild" => "3",
                "getBounds" => "3",
                "getBytesLoaded" => "3",
                "getBytesTotal" => "3",
                "getDate" => "3",
                "getDay" => "3",
                "getDepth" => "3",
                "getInstanceAtDepth" => "3",
                "getNextHighestDepth" => "3",
                "getFullYear" => "3",
                "getHours" => "3",
                "getMilliseconds" => "3",
                "getMinutes" => "3",
                "getMonth" => "3",
                "getNextDepth" => "3",
                "getPan" => "3",
                "getRGB" => "3",
                "getSeconds" => "3",
                "getSWFVersion" => "3",
                "getTime" => "3",
                "getTimezoneOffset" => "3",
                "getTransform" => "3",
                "getURL" => "3",
                "getUTCDate" => "3",
                "getUTCDay" => "3",
                "getUTCFullYear" => "3",
                "getUTCHours" => "3",
                "getUTCMilliseconds" => "3",
                "getUTCMinutes" => "3",
                "getUTCMonth" => "3",
                "getUTCSeconds" => "3",
                "getVolume" => "3",
                "getYear" => "3",
                "globalToLocal" => "3",
                "gotoAndPlay" => "3",
                "gotoAndStop" => "3",
                "hasChildNodes" => "3",
                "hitTest" => "3",
                "indexOf" => "3",
                "insertBefore" => "3",
                "join" => "3",
                "lastChild" => "3",
                "lastIndexOf" => "3",
                "length" => "3",
                "load" => "3",
                "loadMovie" => "3",
                "loadVariables" => "3",
                "loaded" => "3",
                "localToGlobal" => "3",
                "maxscroll" => "3",
                "nextFrame" => "3",
                "nextSibling" => "3",
                "nodeName" => "3",
                "nodeType" => "3",
                "nodeValue" => "3",
                "onClose" => "3",
                "onConnect" => "3",
                "onLoad" => "3",
                "onXML" => "3",
                "parentNode" => "3",
                "parseXML" => "3",
                "play" => "3",
                "pop" => "3",
                "prevFrame" => "3",
                "previousSibling" => "3",
                "push" => "3",
                "removeMovieClip" => "3",
                "removeNode" => "3",
                "reverse" => "3",
                "scroll" => "3",
                "send" => "3",
                "sendAndLoad" => "3",
                "setDate" => "3",
                "setFullYear" => "3",
                "setHours" => "3",
                "setMilliseconds" => "3",
                "setMinutes" => "3",
                "setMonth" => "3",
                "setPan" => "3",
                "setRGB" => "3",
                "setSeconds" => "3",
                "setTime" => "3",
                "setTransform" => "3",
                "setUTCDate" => "3",
                "setUTCFullYear" => "3",
                "setUTCHours" => "3",
                "setUTCMilliseconds" => "3",
                "setUTCMinutes" => "3",
                "setUTCMonth" => "3",
                "setUTCSeconds" => "3",
                "setVolume" => "3",
                "setYear" => "3",
                "shift" => "3",
                "slice" => "3",
                "sort" => "3",
                "sortOn" => "3",
                "splice" => "3",
                "split" => "3",
                "start" => "3",
                "startDrag" => "3",
                "stop" => "3",


                "stopDrag" => "3",
                "substr" => "3",
                "substring" => "3",
                "swapDepths" => "3",
                "toLowerCase" => "3",
                "toString" => "3",
                "prototype" => "3",
                "__proto__" => "3",
                "toUpperCase" => "3",
                "unloadMovie" => "3",
                "getTextSnapshot" => "3",
                "unshift" => "3",
                "valueOf" => "3",
                "xmlDecl" => "3",
                "Array" => "3",
                "CASEINSENSITIVE" => "3",
                "DESCENDING" => "3",
                "UNIQUESORT" => "3",
                "RETURNINDEXEDARRAY" => "3",
                "NUMERIC" => "3",
                "Boolean" => "3",
                "Color" => "3",
                "Date" => "3",
                "UTC" => "3",
                "ALT" => "3",
                "BACKSPACE" => "3",
                "CAPSLOCK" => "3",
                "CONTROL" => "3",
                "DELETEKEY" => "3",
                "DOWN" => "3",
                "END" => "3",
                "ENTER" => "3",
                "ESCAPE" => "3",
                "HOME" => "3",
                "INSERT" => "3",
                "LEFT" => "3",
                "PGDN" => "3",
                "PGUP" => "3",
                "RIGHT" => "3",
                "SHIFT" => "3",
                "SPACE" => "3",
                "TAB" => "3",
                "UP" => "3",
                "getAscii" => "3",
                "getCode" => "3",
                "isDown" => "3",
                "isToggled" => "3",
                "E" => "3",
                "LN10" => "3",
                "LN2" => "3",
                "LOG10E" => "3",
                "LOG2E" => "3",
                "PI" => "3",
                "SQRT1_2" => "3",
                "SQRT2" => "3",
                "abs" => "3",
                "acos" => "3",
                "asin" => "3",
                "atan" => "3",
                "atan2" => "3",
                "ceil" => "3",
                "cos" => "3",
                "exp" => "3",
                "floor" => "3",
                "log" => "3",
                "max" => "3",
                "min" => "3",
                "pow" => "3",
                "random" => "3",
                "round" => "3",
                "sin" => "3",
                "sqrt" => "3",
                "tan" => "3",
                "hide" => "3",
                "show" => "3",
                "Number" => "3",
                "MAX_VALUE" => "3",
                "MIN_VALUE" => "3",
                "NEGATIVE_INFINITY" => "3",
                "NaN" => "3",
                "POSITIVE_INFINITY" => "3",
                "Object" => "3",
                "getBeginIndex" => "3",
                "getCaretIndex" => "3",
                "getEndIndex" => "3",
                "getFocus" => "3",
                "setFocus" => "3",
                "setSelection" => "3",
                "Sound" => "3",
                "String" => "3",
                "fromCharCode" => "3",
                "XML" => "3",
                "XMLNode" => "3",
                "XMLSocket" => "3",
                "addRequestHeader" => "3",
                "call" => "3",
                "chr" => "3",
                "escape" => "3",
                "eval" => "3",
                "false" => "3",
                "fscommand" => "3",
                "getProperty" => "3",
                "getTimer" => "3",
                "getVersion" => "3",
                "ifFrameLoaded" => "3",
                "-Infinity" => "3",
                "Infinity" => "3",
                "int" => "3",
                "isFinite" => "3",
                "isNaN" => "3",
                "keyPress" => "3",
                "loadMovieNum" => "3",
                "loadVariablesNum" => "3",
                "mbchr" => "3",
                "mblength" => "3",
                "mbord" => "3",
                "mbsubstring" => "3",
                "newline" => "3",
                "nextScene" => "3",
                "null" => "3",
                "ord" => "3",
                "parseFloat" => "3",
                "parseInt" => "3",
                "prevScene" => "3",
                "print" => "3",
                "printAsBitmap" => "3",
                "printNum" => "3",
                "printAsBitmapNum" => "3",
                "set" => "3",
                "setProperty" => "3",
                "stopAllSounds" => "3",
                "targetPath" => "3",
                "tellTarget" => "3",
                "this" => "3",
                "toggleHighQuality" => "3",
                "trace" => "3",
                "MMExecute" => "3",
                "true" => "3",
                "undefined" => "3",
                "unescape" => "3",
                "unloadMovieNum" => "3",
                "updateAfterEvent" => "3",
                "press" => "3",
                "release" => "3",
                "releaseOutside" => "3",
                "rollOver" => "3",
                "rollOut" => "3",
                "dragOver" => "3",
                "dragOut" => "3",
                "enterFrame" => "3",
                "unload" => "3",
                "mouseMove" => "3",
                "mouseDown" => "3",
                "mouseUp" => "3",
                "keyDown" => "3",
                "keyUp" => "3",
                "data" => "3",
                "setInterval" => "3",
                "clearInterval" => "3",
                "addProperty" => "3",
                "registerClass" => "3",
                "enabled" => "3",
                "useHandCursor" => "3",
                "unwatch" => "3",
                "watch" => "3",
                "Button" => "3",
                "TextField" => "3",
                "Function" => "3",
                "apply" => "3",
                "_global" => "3",
                "super" => "3",
                "LoadVars" => "3",
                "TextFormat" => "3",
                "autoSize" => "3",
                "removeTextField" => "3",
                "restrict" => "3",
                "createTextField" => "3",
                "html" => "3",
                "variable" => "3",
                "hscroll" => "3",
                "maxhscroll" => "3",
                "border" => "3",
                "background" => "3",
                "wordWrap" => "3",
                "password" => "3",
                "maxChars" => "3",
                "multiline" => "3",
                "textWidth" => "3",
                "textHeight" => "3",
                "selectable" => "3",
                "htmlText" => "3",
                "bottomScroll" => "3",
                "text" => "3",
                "embedFonts" => "3",
                "borderColor" => "3",
                "backgroundColor" => "3",
                "textColor" => "3",
                "font" => "3",
                "size" => "3",
                "color" => "3",
                "url" => "3",
                "target" => "3",
                "bullet" => "3",
                "tabStops" => "3",
                "bold" => "3",
                "italic" => "3",
                "underline" => "3",
                "align" => "3",
                "leftMargin" => "3",
                "rightMargin" => "3",
                "indent" => "3",
                "leading" => "3",
                "replaceSel" => "3",
                "replaceText" => "3",
                "getTextFormat" => "3",
                "setTextFormat" => "3",
                "getNewTextFormat" => "3",
                "setNewTextFormat" => "3",
                "getTextExtent" => "3",
                "getFontList" => "3",
                "condenseWhite" => "3",
                "mouseWheelEnabled" => "3",
                "TextSnapshot" => "3",
                "getCount" => "3",
                "setSelected" => "3",
                "getSelected" => "3",
                "getText" => "3",
                "getSelectedText" => "3",
                "hitTestTextNearPos" => "3",
                "findText" => "3",
                "setSelectColor" => "3",
                "addListener" => "3",
                "removeListener" => "3",
                "focusEnabled" => "3",
                "onPress" => "3",
                "onRelease" => "3",
                "onReleaseOutside" => "3",
                "onRollOver" => "3",
                "onRollOut" => "3",
                "onDragOver" => "3",
                "onDragOut" => "3",
                "onUnload" => "3",
                "onMouseDown" => "3",
                "onMouseMove" => "3",
                "onMouseUp" => "3",
                "onMouseWheel" => "3",
                "onKeyDown" => "3",
                "onKeyUp" => "3",
                "onData" => "3",
                "onChanged" => "3",
                "tabIndex" => "3",
                "tabEnabled" => "3",
                "tabChildren" => "3",
                "hitArea" => "3",
                "onSetFocus" => "3",
                "onKillFocus" => "3",
                "setMask" => "3",
                "isActive" => "3",
                "updateProperties" => "3",
                "createEmptyMovieClip" => "3",
                "beginFill" => "3",
                "beginGradientFill" => "3",
                "moveTo" => "3",
                "lineTo" => "3",
                "curveTo" => "3",
                "lineStyle" => "3",
                "endFill" => "3",
                "get" => "3",
                "install" => "3",
                "list" => "3",
                "uninstall" => "3",
                "showMenu" => "3",
                "scaleMode" => "3",
                "width" => "3",
                "height" => "3",
                "onResize" => "3",
                "capabilities" => "3",
                "security" => "3",
                "useCodepage" => "3",
                "exactSettings" => "3",
                "contentType" => "3",
                "ignoreWhite" => "3",
                "onEnterFrame" => "3",
                "onScroller" => "3",
                "trackAsMenu" => "3",
                "type" => "3",
                "duration" => "3",
                "position" => "3",
                "onSoundComplete" => "3",
                "onID3" => "3",
                "id3" => "3",
                "artist" => "3",
                "album" => "3",
                "songtitle" => "3",
                "year" => "3",
                "genre" => "3",
                "track" => "3",
                "comment" => "3",
                "COMM" => "3",
                "TALB" => "3",
                "TBPM" => "3",
                "TCOM" => "3",
                "TCON" => "3",
                "TCOP" => "3",
                "TDAT" => "3",
                "TDLY" => "3",
                "TENC" => "3",
                "TEXT" => "3",
                "TFLT" => "3",
                "TIME" => "3",
                "TIT1" => "3",
                "TIT2" => "3",
                "TIT3" => "3",
                "TKEY" => "3",
                "TLAN" => "3",
                "TLEN" => "3",
                "TMED" => "3",
                "TOAL" => "3",
                "TOFN" => "3",
                "TOLY" => "3",
                "TOPE" => "3",
                "TORY" => "3",
                "TOWN" => "3",
                "TPE1" => "3",
                "TPE2" => "3",
                "TPE3" => "3",
                "TPE4" => "3",
                "TPOS" => "3",
                "TPUB" => "3",
                "TRCK" => "3",
                "TRDA" => "3",
                "TRSN" => "3",
                "TRSO" => "3",
                "TSIZ" => "3",
                "TSRX" => "3",
                "TSSE" => "3",
                "TYER" => "3",
                "WXXX" => "3",
                "hasAudio" => "3",
                "hasMP3" => "3",
                "hasAudioEncoder" => "3",
                "hasVideoEncoder" => "3",
                "hasEmbeddedVideo" => "3",
                "screenResolutionX" => "3",
                "screenResolutionY" => "3",
                "screenDPI" => "3",
                "screenColor" => "3",
                "pixelAspectRatio" => "3",
                "hasAccessibility" => "3",
                "input" => "3",
                "isDebugger" => "3",
                "language" => "3",
                "manufacturer" => "3",
                "os" => "3",
                "serverString" => "3",
                "version" => "3",
                "hasPrinting" => "3",
                "playerType" => "3",
                "hasStreamingAudio" => "3",
                "hasScreenBroadcast" => "3",
                "hasScreenPlayback" => "3",
                "hasStreamingVideo" => "3",
                "avHardwareDisable" => "3",
                "localFileReadDisable" => "3",
                "windowlessDisable" => "3",
                "Error" => "3",
                "name" => "3",
                "message" => "3",
                "Void" => "3",
                "ContextMenu" => "3",
                "ContextMenuItem" => "3",
                "copy" => "3",
                "hideBuiltInItems" => "3",
                "onSelect" => "3",
                "builtInItems" => "3",
                "save" => "3",
                "zoom" => "3",
                "quality" => "3",
                "loop" => "3",
                "rewind" => "3",
                "forward_back" => "3",
                "customItems" => "3",
                "caption" => "3",
                "separatorBefore" => "3",
                "visible" => "3",
                "attachVideo" => "3",
                "bufferLength" => "3",
                "bufferTime" => "3",
                "currentFps" => "3",
                "onStatus" => "3",
                "pause" => "3",
                "seek" => "3",
                "setBufferTime" => "3",
                "smoothing" => "3",
                "time" => "3",
                "bytesLoaded" => "3",
                "bytesTotal" => "3",
                "NetConnection" => "3",
                "NetStream" => "3",
                "Video" => "3",
                "PrintJob" => "3",
                "addPage" => "3",
                "paperWidth" => "3",
                "paperHeight" => "3",
                "pageWidth" => "3",
                "pageHeight" => "3",
                "orientation" => "3",
                "MovieClipLoader" => "3",
                "loadClip" => "3",
                "unloadClip" => "3",
                "getProgress" => "3",
                "onLoadStart" => "3",
                "onLoadProgress" => "3",
                "onLoadComplete" => "3",
                "onLoadInit" => "3",
                "onLoadError" => "3",
                "styleSheet" => "3",
                "StyleSheet" => "3",
                "parse" => "3",
                "parseCSS" => "3",
                "getStyle" => "3",
                "setStyle" => "3",
                "getStyleNames" => "3",
                "transform" => "3",
                "activityLevel" => "3",
                "allowDomain" => "3",
                "allowInsecureDomain" => "3",
                "attachAudio" => "3",
                "bandwidth" => "3",
                "deblocking" => "3",
                "domain" => "3",
                "flush" => "3",
                "fps" => "3",
                "gain" => "3",
                "getLocal" => "3",
                "getRemote" => "3",
                "getSize" => "3",
                "index" => "3",
                "isConnected" => "3",
                "keyFrameInterval" => "3",
                "liveDelay" => "3",
                "loopback" => "3",
                "motionLevel" => "3",
                "motionTimeOut" => "3",
                "menu" => "3",
                "muted" => "3",
                "names" => "3",
                "onActivity" => "3",
                "onSync" => "3",
                "publish" => "3",
                "rate" => "3",
                "receiveAudio" => "3",
                "receiveVideo" => "3",
                "setFps" => "3",
                "setGain" => "3",
                "setKeyFrameInterval" => "3",
                "setLoopback" => "3",
                "setMode" => "3",
                "setMotionLevel" => "3",
                "setQuality" => "3",
                "setRate" => "3",
                "setSilenceLevel" => "3",
                "setUseEchoSuppression" => "3",
                "showSettings" => "3",
                "setClipboard" => "3",
                "silenceLevel" => "3",
                "silenceTimeOut" => "3",
                "useEchoSuppression" => "3",
                "textFieldHeight" => "3",
                "textFieldWidth" => "3",
                "ascent" => "3",
                "descent" => "3",
                "Camera" => "3",
                "LocalConnection" => "3",
                "Microphone" => "3",
                "SharedObject" => "3",
                "System" => "3",
                "Math" => "3",
                "Selection" => "3",
                "CustomActions" => "3",
                "Stage" => "3",
// properties
                "_alpha" => "4",
                "_currentframe" => "4",
                "_droptarget" => "4",
                "_focusrect" => "4",
                "_framesloaded" => "4",
                "_height" => "4",
                "_highquality" => "4",
                "_lockroot" => "4",
                "_name" => "4",
                "_quality" => "4",
                "_rotation" => "4",
                "_soundbuftime" => "4",
                "_target" => "4",
                "_totalframes" => "4",
                "_url" => "4",
                "_width" => "4",
                "_visible" => "4",
                "_x" => "4",
                "_xmouse" => "4",
                "_xscale" => "4",
                "_y" => "4",
                "_ymouse" => "4",
                "_yscale" => "4",
// component identifiers
                "Form" => "5",
                "Slide" => "5",
                "addEventListener" => "5",
                "allTransitionsInDone" => "5",
                "allTransitionsOutDone" => "5",
                "autoKeyNav" => "5",
                "autoLoad" => "5",
                "bytesLoaded" => "5",
                "bytesTotal" => "5",
                "complete" => "5",
                "content" => "5",
                "contentPath" => "5",
                "createClassObject" => "5",
                "createObject" => "5",
                "currentChildSlide" => "5",
                "currentFocusedForm" => "5",
                "currentFocusedScreen" => "5",
                "currentFocusedSlide" => "5",
                "currentSlide" => "5",
                "defaultKeyDownHandler" => "5",
                "destroyObject" => "5",
                "draw" => "5",
                "enabled" => "5",
                "firstSlide" => "5",
                "focusIn" => "5",
                "focusOut" => "5",
                "getChildAt" => "5",
                "getChildForm" => "5",
                "getChildScreen" => "5",
                "getChildSlide" => "5",
                "getFocus" => "5",
                "getStyle" => "5",
                "gotoFirstSlide" => "5",
                "gotoLastSlide" => "5",
                "gotoNextSlide" => "5",
                "gotoPreviousSlide" => "5",
                "gotoSlide" => "5",
                "handleEvent" => "5",
                "hide" => "5",
                "hideChild" => "5",
                "indexInParent" => "5",
                "indexInParentForm" => "5",
                "indexInParentSlide" => "5",
                "invalidate" => "5",
                "keyDown" => "5",
                "keyUp" => "5",
                "lastSlide" => "5",
                "load" => "5",
                "mouseDown" => "5",
                "mouseDownSomewhere" => "5",
                "mouseMove" => "5",
                "mouseOut" => "5",
                "mouseOver" => "5",
                "mouseUp" => "5",
                "mouseUpSomewhere" => "5",
                "move" => "5",
                "nextSlide" => "5",
                "numChildForms" => "5",
                "numChildScreens" => "5",
                "numChildSlides" => "5",
                "numChildren" => "5",
                "overlayChildren" => "5",
                "parentForm" => "5",
                "parentIsForm" => "5",
                "parentIsScreen" => "5",
                "parentIsSlide" => "5",
                "parentScreen" => "5",
                "parentSlide" => "5",
                "percentLoaded" => "5",
                "playHidden" => "5",
                "previousSlide" => "5",
                "progress" => "5",
                "redraw" => "5",
                "resize" => "5",
                "reveal" => "5",
                "revealChild" => "5",
                "rootForm" => "5",
                "rootScreen" => "5",
                "rootSlide" => "5",
                "scaleContent" => "5",
                "scaleX" => "5",
                "scaleY" => "5",
                "setFocus" => "5",
                "setSize" => "5",
                "setStyle" => "5",
                "unload" => "5",
                "visible" => "5",
                "Binding" => "5",
                "ComponentMixins" => "5",
                "DataAccessor" => "5",
                "DataHolder" => "5",
                "DataSet" => "5",
                "DataType" => "5",
                "Delta" => "5",
                "DeltaItem" => "5",
                "DeltaPacket" => "5",
                "EndPoint" => "5",
                "Log" => "5",
                "PendingCall" => "5",
                "RDBMSResolver" => "5",
                "SOAPCall" => "5",
                "TypedValue" => "5",
                "URL" => "5",
                "WSDLURL" => "5",
                "WebService" => "5",
                "WebServiceConnector" => "5",
                "XMLConnector" => "5",
                "XUpdateResolver" => "5",
                "addDeltaItem" => "5",
                "addFieldInfo" => "5",
                "addHeader" => "5",
                "addItem" => "5",
                "addItemAt" => "5",
                "addSort" => "5",
                "afterLoaded" => "5",
                "applyUpdates" => "5",
                "argList" => "5",
                "beforeApplyUpdates" => "5",
                "calcFields" => "5",
                "changesPending" => "5",
                "clear" => "5",
                "component" => "5",
                "concurrency" => "5",
                "constant" => "5",
                "createItem" => "5",
                "curValue" => "5",
                "currentItem" => "5",
                "data" => "5",
                "dataProvider" => "5",
                "delta" => "5",
                "deltaPacket" => "5",
                "deltaPacketChanged" => "5",
                "direction" => "5",
                "disableEvents" => "5",
                "doDecoding" => "5",
                "doLazyDecoding" => "5",
                "enableEvents" => "5",
                "encoder" => "5",
                "event" => "5",
                "execute" => "5",
                "fieldInfo" => "5",
                "filterFunc" => "5",
                "filtered" => "5",
                "find" => "5",
                "findFirst" => "5",
                "findLast" => "5",
                "first" => "5",
                "formatter" => "5",
                "getAnyTypedValue" => "5",
                "getAsBoolean" => "5",
                "getAsNumber" => "5",
                "getAsString" => "5",
                "getCall" => "5",
                "getChangeList" => "5",
                "getConfigInfo" => "5",
                "getDeltaPacket" => "5",
                "getField" => "5",
                "getId" => "5",
                "getItemByName" => "5",
                "getItemId" => "5",
                "getIterator" => "5",
                "getLength" => "5",
                "getMessage" => "5",
                "getOperation" => "5",
                "getOutputParameter" => "5",
                "getOutputParameterByName" => "5",
                "getOutputParameters" => "5",
                "getOutputValue" => "5",
                "getOutputValues" => "5",
                "getSource" => "5",
                "getTimestamp" => "5",
                "getTransactionId" => "5",
                "getTypedValue" => "5",
                "hasNext" => "5",
                "hasPrevious" => "5",
                "hasSort" => "5",
                "ignoreWhite" => "5",
                "includeDeltaPacketInfo" => "5",
                "initComponent" => "5",
                "isEmpty" => "5",
                "itemClassName" => "5",
                "items" => "5",
                "iteratorScrolled" => "5",
                "kind" => "5",
                "last" => "5",
                "length" => "5",
                "loadFromSharedObj" => "5",
                "locateById" => "5",
                "location" => "5",
                "logChanges" => "5",
                "message" => "5",
                "modelChanged" => "5",
                "multipleSimultaneousAllowed" => "5",
                "mx" => "5",
                "binding" => "5",
                "components" => "5",
                "services" => "5",
                "screens" => "5",
                "datasetclasses" => "5",
                "containers" => "5",
                "managers" => "5",
                "myCall" => "5",
                "name" => "5",
                "newItem" => "5",
                "newValue" => "5",
                "next" => "5",
                "nullValue" => "5",
                "oldValue" => "5",
                "onFault" => "5",
                "onLoad" => "5",
                "onLog" => "5",
                "onResult" => "5",
                "operation" => "5",
                "params" => "5",
                "previous" => "5",
                "properties" => "5",
                "property" => "5",
                "readOnly" => "5",
                "reconcileResults" => "5",
                "reconcileUpdates" => "5",
                "refreshDestinations" => "5",
                "refreshFromSources" => "5",
                "removeAll" => "5",
                "removeEventListener" => "5",
                "removeItem" => "5",
                "removeItemAt" => "5",
                "removeRange" => "5",
                "removeSort" => "5",
                "request" => "5",
                "resolveDelta" => "5",
                "response" => "5",
                "result" => "5",
                "results" => "5",
                "saveToSharedObj" => "5",
                "schema" => "5",
                "selectedIndex" => "5",
                "send" => "5",
                "setAnyTypedValue" => "5",
                "setAsBoolean" => "5",
                "setAsNumber" => "5",
                "setAsString" => "5",
                "setIterator" => "5",
                "setRange" => "5",
                "setTypedValue" => "5",
                "skip" => "5",
                "status" => "5",
                "suppressInvalidCalls" => "5",
                "tableName" => "5",
                "trigger" => "5",
                "typeName" => "5",
                "updateMode" => "5",
                "updatePacket" => "5",
                "updateResults" => "5",
                "useSort" => "5",
                "validateProperty" => "5",
                "value" => "5",
                "xupdatePacket" => "5",
                "Accordion" => "5",
                "Alert" => "5",
                "Button" => "5",
                "CheckBox" => "5",
                "ComboBox" => "5",
                "DataGrid" => "5",
                "DateChooser" => "5",
                "DateField" => "5",
                "Label" => "5",
                "List" => "5",
                "Loader" => "5",
                "MediaController" => "5",
                "MediaDisplay" => "5",
                "MediaPlayback" => "5",
                "Menu" => "5",
                "MenuBar" => "5",
                "NumericStepper" => "5",
                "PopUpManager" => "5",
                "ProgressBar" => "5",
                "RadioButton" => "5",
                "RadioButtonGroup" => "5",
                "ScrollPane" => "5",
                "TextArea" => "5",
                "TextInput" => "5",
                "Tree" => "5",
                "Window" => "5",
                "_accProps" => "5",
                "activePlayControl" => "5",
                "addColumn" => "5",
                "addColumnAt" => "5",
                "addCuePoint" => "5",
                "addMenu" => "5",
                "addMenuAt" => "5",
                "addMenuItem" => "5",
                "addMenuItemAt" => "5",
                "addTreeNode" => "5",
                "addTreeNodeAt" => "5",
                "aspectRatio" => "5",
                "associateController" => "5",
                "associateDisplay" => "5",
                "autoPlay" => "5",
                "autoSize" => "5",
                "backgroundStyle" => "5",
                "buttonHeight" => "5",
                "buttonStyleDeclaration" => "5",
                "buttonWidth" => "5",
                "cancelLabel" => "5",
                "cellEdit" => "5",
                "cellFocusIn" => "5",
                "cellFocusOut" => "5",
                "cellPress" => "5",
                "cellRenderer" => "5",
                "change" => "5",
                "click" => "5",
                "close" => "5",
                "closeButton" => "5",
                "columnCount" => "5",
                "columnNames" => "5",
                "columnStretch" => "5",
                "controlPlacement" => "5",
                "controllerPolicy" => "5",
                "conversion" => "5",
                "createChild" => "5",
                "createMenu" => "5",
                "createPopUp" => "5",
                "createSegment" => "5",
                "cuePoint" => "5",
                "cuePoints" => "5",
                "dateFormatter" => "5",
                "dayNames" => "5",
                "deletePopUp" => "5",
                "destroyChildAt" => "5",
                "disabledDays" => "5",
                "disabledRanges" => "5",
                "displayFull" => "5",
                "displayNormal" => "5",
                "displayedMonth" => "5",
                "displayedYear" => "5",
                "doLayout" => "5",
                "dropdown" => "5",
                "dropdownWidth" => "5",
                "editField" => "5",
                "editable" => "5",
                "enter" => "5",
                "firstDayOfWeek" => "5",
                "firstVisibleNode" => "5",
                "focusedCell" => "5",
                "getBytesLoaded" => "5",
                "getBytesTotal" => "5",
                "getColumnAt" => "5",
                "getColumnIndex" => "5",
                "getCuePoints" => "5",
                "getDisplayIndex" => "5",
                "getIsBranch" => "5",
                "getIsOpen" => "5",
                "getItemAt" => "5",
                "getMenuAt" => "5",
                "getMenuEnabledAt" => "5",
                "getMenuItemAt" => "5",
                "getNodeDisplayedAt" => "5",
                "getTreeNodeAt" => "5",
                "groupName" => "5",
                "hLineScrollSize" => "5",
                "hPageScrollSize" => "5",
                "hPosition" => "5",
                "hScrollPolicy" => "5",
                "headerHeight" => "5",
                "headerRelease" => "5",
                "horizontal" => "5",
                "html" => "5",
                "icon" => "5",
                "iconField" => "5",
                "iconFunction" => "5",
                "indeterminate" => "5",
                "indexOf" => "5",
                "itemRollOut" => "5",
                "itemRollOver" => "5",
                "label" => "5",
                "labelField" => "5",
                "labelFunction" => "5",
                "labelPlacement" => "5",
                "maxChars" => "5",
                "maxHPosition" => "5",
                "maxVPosition" => "5",
                "maximum" => "5",
                "mediaType" => "5",
                "menuHide" => "5",
                "menuShow" => "5",
                "messageStyleDeclaration" => "5",
                "minimum" => "5",
                "mode" => "5",
                "monthNames" => "5",
                "mouseDownOutside" => "5",
                "multipleSelection" => "5",
                "mxmanagersPopUpManager" => "5",
                "nextValue" => "5",
                "noLabel" => "5",
                "nodeClose" => "5",
                "nodeOpen" => "5",
                "okLabel" => "5",
                "open" => "5",
                "password" => "5",
                "pause" => "5",
                "percentComplete" => "5",
                "play" => "5",
                "playheadChange" => "5",
                "playheadTime" => "5",
                "playing" => "5",
                "preferredHeight" => "5",
                "preferredWidth" => "5",
                "previousValue" => "5",
                "pullDown" => "5",
                "refresh" => "5",
                "refreshPane" => "5",
                "removeAllColumns" => "5",
                "removeAllCuePoints" => "5",
                "removeColumnAt" => "5",
                "removeCuePoint" => "5",
                "removeMenuAt" => "5",
                "removeMenuItem" => "5",
                "removeMenuItemAt" => "5",
                "removeTreeNodeAt" => "5",
                "replaceItemAt" => "5",
                "resizableColumns" => "5",
                "restrict" => "5",
                "rowCount" => "5",
                "rowHeight" => "5",
                "scroll" => "5",
                "scrollDrag" => "5",
                "selectable" => "5",
                "selectableRange" => "5",
                "selected" => "5",
                "selectedChild" => "5",
                "selectedData" => "5",
                "selectedDate" => "5",
                "selectedIndices" => "5",
                "selectedItem" => "5",
                "selectedItems" => "5",
                "selectedNode" => "5",
                "selectedNodes" => "5",
                "selection" => "5",
                "setHPosition" => "5",
                "setIcon" => "5",
                "setIsBranch" => "5",
                "setIsOpen" => "5",
                "setMedia" => "5",
                "setMenuEnabledAt" => "5",
                "setMenuItemEnabled" => "5",
                "setMenuItemSelected" => "5",
                "setProgress" => "5",
                "setPropertiesAt" => "5",
                "setVPosition" => "5",
                "show" => "5",
                "showHeaders" => "5",
                "showToday" => "5",
                "sortItems" => "5",
                "sortItemsBy" => "5",
                "sortableColumns" => "5",
                "source" => "5",
                "spaceColumnsEqually" => "5",
                "start" => "5",
                "stepSize" => "5",
                "stop" => "5",
                "tabIndex" => "5",
                "text" => "5",
                "textField" => "5",
                "title" => "5",
                "titleStyleDeclaration" => "5",
                "toggle" => "5",
                "totalTime" => "5",
                "vLineScrollSize" => "5",
                "vPageScrollSize" => "5",
                "vPosition" => "5",
                "vScrollPolicy" => "5",
                "volume" => "5",
                "wordWrap" => "5",
                "yesLabel" => "5",
                "arrow" => "5",
                "background" => "5",
                "backgroundDisabled" => "5",
                "check" => "5",
                "darkshadow" => "5",
                "embedFonts" => "5",
                "face" => "5",
                "foregroundDisabled" => "5",
                "focusRectOuter" => "5",
                "focusRectInner" => "5",
                "highlight" => "5",
                "highlight3D" => "5",
                "radioDot" => "5",
                "scrollTrack" => "5",
                "selectionDisabled" => "5",
                "selectionUnfocused" => "5",
                "shadow" => "5",
                "textAlign" => "5",
                "textBold" => "5",
                "textColor" => "5",
                "textDisabled" => "5",
                "textFont" => "5",
                "textIndent" => "5",
                "textItalic" => "5",
                "textLeftMargin" => "5",
                "textRightMargin" => "5",
                "textSelected" => "5",
                "textSize" => "5",
                "textUnderline" => "5",
                "__resolve" => "5",
                "acceptConnection" => "5",
                "activityLevel" => "5",
                "agent" => "5",
                "allowDomain" => "5",
                "attachAudio" => "5",
                "attachVideo" => "5",
                "bandwidth" => "5",
                "bufferLength" => "5",
                "bufferTime" => "5",
                "call" => "5",
                "clearInterval" => "5",
                "clearSharedObjects" => "5",
                "clearStreams" => "5",
                "clients" => "5",
                "connect" => "5",
                "currentFps" => "5",
                "deblocking" => "5",
                "disconnect" => "5",
                "domain" => "5",
                "flush" => "5",
                "fps" => "5",
                "gain" => "5",
                "get" => "5",
                "getBandwidthLimit" => "5",
                "getLocal" => "5",
                "getProperty" => "5",
                "getPropertyNames" => "5",
                "getRemote" => "5",
                "getSize" => "5",
                "getStats" => "5",
                "handlerName" => "5",
                "height" => "5",
                "hostname" => "5",
                "index" => "5",
                "ip" => "5",
                "isConnected" => "5",
                "keyFrameInterval" => "5",
                "liveDelay" => "5",
                "lock" => "5",
                "loopback" => "5",
                "motionLevel" => "5",
                "motionTimeOut" => "5",
                "muted" => "5",
                "names" => "5",
                "onActivity" => "5",
                "onAppStart" => "5",
                "onAppStop" => "5",
                "onConnect" => "5",
                "onDisconnect" => "5",
                "onStatus" => "5",
                "onSync" => "5",
                "ping" => "5",

                "protocol" => "5",
                "publish" => "5",
                "purge" => "5",
                "quality" => "5",
                "rate" => "5",
                "readAccess" => "5",
                "receiveAudio" => "5",
                "receiveVideo" => "5",
                "record" => "5",
                "referrer" => "5",
                "registerClass" => "5",
                "registerProxy" => "5",
                "rejectConnection" => "5",
                "resyncDepth" => "5",
                "seek" => "5",
                "server" => "5",
                "setBandwidthLimit" => "5",
                "setBufferTime" => "5",
                "setFps" => "5",
                "setGain" => "5",
                "setInterval" => "5",
                "setKeyFrameInterval" => "5",
                "setLoopback" => "5",
                "setMode" => "5",
                "setMotionLevel" => "5",
                "setProperty" => "5",
                "setQuality" => "5",
                "setRate" => "5",
                "setSilenceLevel" => "5",
                "setUseEchoSuppression" => "5",
                "showSettings" => "5",

                "silenceLevel" => "5",
                "silenceTimeout" => "5",
                "size" => "5",
                "smoothing" => "5",
                "time" => "5",
                "trace" => "5",
                "unlock" => "5",
                "uri" => "5",
                "useEchoSuppression" => "5",
                "version" => "5",
                "width" => "5",
                "writeAccess" => "5",
                "Application" => "5",
                "Camera" => "5",
                "Client" => "5",
                "Global" => "5",
                "LocalConnection" => "5",
                "Microphone" => "5",
                "MovieClip" => "5",
                "NetConnection" => "5",
                "NetStream" => "5",
                "SharedObject" => "5",
                "Stream" => "5",
                "System" => "5",
                "Video" => "5",
                "NetServices" => "5",
                "setDefaultGatewayUrl" => "5",
                "createGatewayConnection" => "5",
                "getService" => "5",
                "setCredentials" => "5",
                "RecordSet" => "5",
                "getColumnNames" => "5",
                "addView" => "5",
                "filter" => "5",
                "setField" => "5",
                "sort" => "5",
                "isLocal" => "5",
                "isFullyPopulated" => "5",
                "getNumberAvailable" => "5",
                "setDeliveryMode" => "5",
                );
                
                # Special extensions
                
                # Each category can specify a PHP function that takes in the function name, and returns a link.
                # This link is then placed in a <a href="...">foo</a>; structure around keyword 'foo' - which is
                # great for doing links to manuals, etc.
                
                $this->linkscripts        = array(
                            "1" => "donothing",
                            "2" => "donothing",
                            "3" => "donothing",
                            "4" => "donothing",
                            "5" => "donothing");
        }
        # DoNothing link function
        function donothing($keywordin)
        {
                    return $keywordin;
        }
        
}?>